--   Programming Language Technology:
--   Putting Formal Languages to Work
--
--   Andreas Abel, 11 May 2017
--
-- Guest lecture in class
--
--   Finite Automata Theory and Formal Languages
--   TMV027/DIT321, LP4 2017
--   http://www.cse.chalmers.se/edu/course/TMV027/

-- Calculator semantics: evaluation.

module CalcEval where

type Env  = [(String, Integer)]  -- Environment
type Calc = Env -> Integer       -- Interpretation of expressions

plus :: Calc -> Calc -> Calc
plus e1 e2 env = e1 env + e2 env

times :: Calc -> Calc -> Calc
times e1 e2 env = e1 env * e2 env

number :: Integer -> Calc
number i env = i

variable :: String -> Calc
variable x env =
  case lookup x env of
    Just i  -> i
    Nothing -> error ("undefined variable " ++ x)

local :: String -> Calc -> Calc -> Calc
local x e1 e2 env = e2 ((x, e1 env) : env)
